 clear;
 example = 6 ;
 
%     
%   Example = 1  
%
%            C ---r4----D
%           /  \       /  
%          r3   r2    r5  
%         /       \  /    
%   --r6--A---r1----B----r7----
%
    if example == 1        
        disp('from Dr.Dan Jan. 2004')                            
        S = [ -1   0   1   0   0  1   0 
               1  -1   0   0   1  0  -1
               0   1  -1  -1   0  0   0 
               0   0   0   1  -1  0   0 ];                                                            
    end 


%   Example = 2
%   From Fishtik et al. (J. Phys. Chem 108:5671-5682, 2004):
%  
    if example == 2
       disp('for Fishtik test')  
       S = [  -1    0    0    0    0    0    0    0    0    0    -1    0    0    % T1
               0   -1    0    0    0    0    0    0    0    0     0   -1    0    % T2
               0    0    0    0    0    0   +1    0    0    0     0    0   +1    % T3
              +1    0   -1    0    0    0    0   -1    0    0     0    0    0    % I1
               0   +2   -1   -1   +2   +1    0   +1   -1   -2     0    0    0    % I2
               0    0    0    0    0   +1    0    0   +1   -1     0    0    0    % I3
               0    0    0    0   +1    0    0   +1   -1    0     0    0    0    % I4
               0    0   +1   -1   -1   -1    0    0    0    0     0    0    0    % I5
               0    0    0   +1    0    0   -1    0    0   +1     0    0    0];  % I6             
    end

%
%   Example = 3  
%   From Datta et al. (30 June 2004), 201 cycles
%     
    if example == 3
        disp('for Datta test') 
        %    s1   s2   s3   s4   s5   s6   s7   s8   s9   s10  s11  s12  s13  s14  s15  s16  s17   OR
        S = [-1    0    0    0    0    0    0    0    0    0    0    0    0    0    0    0    0   -1     % CO
             -1   -1   +1   +1   +1   -1   +1   +1   -1    0   -1    0    0    0    0    0    0    0     % S
             +1    0    0    0    0    0   -1   -1    0   -1    0    0    0    0    0    0    0    0     % COS
              0   -1    0    0    0    0    0    0    0    0    0    0    0    0    0    0    0   -1     % H2O
              0   +1    0    0    0   -1    0    0    0    0    0    0   -1   -1    0   +1    0    0     % H2OS
              0    0   +1    0    0    0    0    0    0    0    0    0    0    0    0    0    0   +1     % CO2
              0    0   -1    0    0    0   +1    0    0   +1   +1   +1    0    0    0   +1   +1    0     % CO2S
              0    0    0   -2    0   +1    0    0   +1   +1   +1    0    0   -1   -1    0   -1    0     % HS
              0    0    0   +1   -1    0    0    0    0    0    0    0    0   +1   +1    0   +1    0     % H2S
              0    0    0    0   +1    0    0    0    0    0    0    0    0    0    0    0    0   +1     % H2
              0    0    0    0    0   +1    0   -1   -1   -1    0   +1   +2   +1   -1   -1    0    0     % OHS
              0    0    0    0    0    0   -1    0   +1    0    0   -1   -1    0   +1    0    0    0     % OS
              0    0    0    0    0    0    0   +1    0    0   -1   -1    0    0    0   -1   -1    0];   % HCOOS
    end

 
%   Example = 4
% 
%       B ---r3---D---r7--- 
%       |  \      |
%       r2  r1    r4
%       |      \  |
% --r6- A ---r5---C---r8--- 
%
    if example == 4
        disp('test 4') 
  
        %    s1  s2  s3  s4  s5  s6  s7  s8    
        S = [ 0  -1   0   0  -1  +1   0   0
             -1  +1  -1   0   0   0   0   0
             +1   0   0  +1  +1   0   0  -1
              0   0  +1  -1   0   0  -1   0 ];         
    end    
            
    if example == 5      % huge one, has not found complete cycles yet.
       disp('test 5')  
       S = [
         0  0  0  0  0  0  0  0  1  0  0  0  0  0  0  0  0  0  0  0  0  0 -1  0 
         0  0  0  0  0  0  1  0  0  0  0  0  0  0  0  0 -1 -1  0  0  0  0  0  0 
         0  0  0  0  0  0 -1  1 -1  0  0  0  0  0  0  0  0  0  0  0  0 -1  0  0 
         0  0  0  0  0  0  0  0  0  0  0  0  0  0  1 -1  0  0  0  0  0  0  0  0 
         0  0  0  0  1 -1  0  0  0  0  0  0  0  0  0  1  0  0  0  0  0  0  0  0 
         0  0  0  1 -1  0  0  0  0  0  0  0  0  0  0  0  0  1  0  0  0  0  0  0 
         0  0  1 -1  0  0  0  0  0  0  0  0  0  0  1  0  0  0  0  0  0  0  0  0 
         0  0 -1  0  0  0  0  0  0  0  0  0  0  1  0  0  0  0  0  0  0  0  0 -1 
         0  0  0  0  0  0  1 -1  1  0  0  0  1 -1  0  0  0  0  0  0  0  0  0  0 
         0  1  0  0  0  0  0  0  0  0  0  0 -1  0 -1  0  0  0  0  0  0  0  0  0 
         0 -1  0  0  0  0  0  0  0  0  0  1  0  0  0  0  0  0  0  0  0  0  0  0 
         0  0  0  0  0  1 -1  0  0  0  0 -1  0  0  0  0  0  0 -1  1  0  0  0  0 
         0  0  0  0  0  0  0  0  0  0  1 -1  0  0  0 -1  0  0  0  0  0  0  0  0 
         0  0  1  0  0  0  0  0  0  0 -1  1  0 -1  0  1  0  0  0  0  0  0  0  1 
         0  0  0  0  0  0  0  0 -1  1 -1  0  0  0  0  0  0  0  0  0 -1  0  0  0 
         1  0  0  0  0  0  0  0  0 -1  0  0  0  0  0  0  0  0  1 -1  1  0  0  0];
    end
    
 if example == 6
     load S234.mat;   % S=[52*47], 7 null spaces, has 234 cycles.  
 end
 
 if example == 7
     load S.mat;   % has S=[230*218], not found complete cycles yet. 20 null spaces
 end     
      
%  
%   %---------------------------------%
%   |                                 |
%   |   M A I N  F U N C T I O N      |
%   |                                 |
%   %---------------------------------%
%    
    
    %profile on

    tic; 
    C = cycles(S);
    cost_time = toc 
     
    %profile viewer